local function OnActivate_Triangle(inst, doer, target)
	if  not inst.components.triangle_marks:CheckMark() then
		inst.components.triangle_marks:MarkEntrance()
	end

	if doer:HasTag("player") then
		doer.components.health:SetInvincible(true)
		if TUNING.DO_SEA_DAMAGE_TO_BOAT and (doer.components.driver and doer.components.driver.vehicle and doer.components.driver.vehicle.components.boathealth) then
			doer.components.driver.vehicle.components.boathealth:SetInvincible(true)
		end
		doer.components.playercontroller:Enable(false)

		if inst.components.teleporter.targetTeleporter ~= nil then
			local other = inst.components.teleporter.targetTeleporter
			if not other.components.triangle_marks:CheckMark() then
				other.components.triangle_marks:MarkExit()
			end
			GLOBAL.DeleteCloseEntsWithTag(inst.components.teleporter.targetTeleporter, "WORM_DANGER", 15)
		end

		GLOBAL.GetPlayer().HUD:Hide()
		GLOBAL.TheCamera:SetTarget(inst)
		TheFrontEnd:Fade(false, 0.5)
		doer:DoTaskInTime(2, function()
			GLOBAL.TheCamera:SetTarget(target)
			GLOBAL.TheCamera:Snap()
			TheFrontEnd:Fade(true, 0.5)
			GLOBAL.GetPlayer().HUD:Show()
			if doer.components.sanity then
				doer.components.sanity:DoDelta(-TUNING.SANITY_MED)
			end
		end)
		doer:DoTaskInTime(3.5, function()
			GLOBAL.TheCamera:SetTarget(GLOBAL.GetPlayer())
			doer:PushEvent("bermudatriangleexit")
			doer.components.health:SetInvincible(false)
			if TUNING.DO_SEA_DAMAGE_TO_BOAT and (doer.components.driver and doer.components.driver.vehicle and doer.components.driver.vehicle.components.boathealth) then
				doer.components.driver.vehicle.components.boathealth:SetInvincible(false)
			end
			doer.components.playercontroller:Enable(true)
		end)
	elseif doer.SoundEmitter then
		inst.SoundEmitter:PlaySound("dontstarve_DLC002/common/bermudatriangle_spark", "wormhole_swallow")
	end
end

local DLC = GLOBAL.rawget(GLOBAL, "PORKLAND_DLC") and GLOBAL.IsDLCEnabled(GLOBAL.PORKLAND_DLC)
if DLC then
	Assets =
	{
		Asset("ATLAS", "images/triangle/triangle_1.xml"),
		Asset("ATLAS", "images/triangle/triangle_2.xml"),
		Asset("ATLAS", "images/triangle/triangle_3.xml"),
		Asset("ATLAS", "images/triangle/triangle_4.xml"),
		Asset("ATLAS", "images/triangle/triangle_5.xml"),
		Asset("ATLAS", "images/triangle/triangle_6.xml"),
		Asset("ATLAS", "images/triangle/triangle_7.xml"),
		Asset("ATLAS", "images/triangle/triangle_8.xml"),
	}

	AddMinimapAtlas("images/triangle/triangle_1.xml")
	AddMinimapAtlas("images/triangle/triangle_2.xml")
	AddMinimapAtlas("images/triangle/triangle_3.xml")
	AddMinimapAtlas("images/triangle/triangle_4.xml")
	AddMinimapAtlas("images/triangle/triangle_5.xml")
	AddMinimapAtlas("images/triangle/triangle_6.xml")
	AddMinimapAtlas("images/triangle/triangle_7.xml")
	AddMinimapAtlas("images/triangle/triangle_8.xml")

	function TrianglePrefabPostInit(inst)
		inst:AddComponent("triangle_marks")
		if inst and inst.components.teleporter then
			inst.components.teleporter.onActivate = OnActivate_Triangle
		end
	end
	AddPrefabPostInit("bermudatriangle", TrianglePrefabPostInit)

	function ShipwreckedPrefabPostInit(inst)
		inst:AddComponent("triangle_counter")
	end
	AddPrefabPostInit("shipwrecked", ShipwreckedPrefabPostInit)
end
